Subject: [Cbor] Minutes IETF99 CBOR

From: Francesca Palombini <[email-masked]>
Date: Mon, 24 Jul 2017 09:06:18 +0000

Hi all,

Thank you for a very interesting meeting in Prague.
Here below you can find the minutes for the second CBOR meeting. Thanks a lot Paul for taking them!

Please let us know if you have any comment, as soon as possible, and no later than 2017-09-03.

Thanks,
Francesca

CBOR WG minutes
IETF 99 - Prague
Monday, July 17, 2017, 15:50 - 17:20
Chairs: Joe Hildebrand, Francesca Palombini Acting chair: Matthew Miller Minutes taken by Paul Hoffman, Francesca Palombini
    Text from the slides is not reproduced here; only differences and additions
    See https://datatracker.ietf.org/meeting/99/session/cbor for slides

CBOR specification status: Carsten
    https://tools.ietf.org/html/draft-ietf-cbor-7049bis-00

    * About tag registry (sl. 5)
    Michael Richardson: If you want to put a circuit breaker in, you need to redefine the second half ot the space to have expert review with different criteria. Two experts criteria ranges.
    Carsten: Good point, let's take that offline.

    * About implementations (sl. 8)
    ?: IPFS uses CBOR, so we should find out which library it uses
    Carsten: True for other protocols.
    Call to action: Look at the wiki page and send comments on the list about implementation features.

    * Which implementations (sl. 10)
    Francesca: Let's start with defining the most used/common libraries. Please start the discussion to the mailing list.
    Alexey: to clarify, any feature you have to have 2 independent implementation, no need to be the same implementations. 4 or 5 implementations could cover this.
    Paul: do we need to show uses of each tag?
        Alexey: Go ahead, fill in the table, find the gaps and later decide if they are unused features, if they greatly increase implementation complexity, separate document or not.
    Sean Leonard: what does "implementation" mean? Because you can tag anything with anything in CBOR...does it have to validate? reject non-conforming data?
    Carsten: hopefully we don't have to define conformity.

    Francesca: Start with what Alexey has said, then go to the list about the tag issue. Timeline?
    Carsten: end of September we should be done.

    Call to action: Please do comment on things that are unclear, even editorial, use the github or mailing list

    Carsten: from offline discussion: CBOR document doesn't say what kind of Unicode you find in UTF-8 strings
        Clear that it has to be valid UTF-8
        People might have different views of what other restrictions there should be

    Francesca: any other comment, take it to the list.

CDDL: Carsten
    https://tools.ietf.org/html/draft-greevenbosch-appsawg-cbor-cddl-11

    * Status (sl. 13)
    Alexey: Put this on Standards Track

    * Name change (sl. 14)
    Francesca (chair hat off): If we do keep the name, liked keeping the name with "CBOR"

    * Comments
    Jeffery Yasskin: Wants to be able "parse these bytes with CDDL", that's not precisely defined in current spec. Would be nice to have that.
        Carsten: mabye need to add a syntax tree. Also think useful but maybe a different project. Let's fix the acceptance part

    Carsten: When do we want to be done? Hope this to be the last round. WG last call before Singapore.

    Francesca: Any strong objections to moving this to standards track?
    Sean Leonard: has concerns about standards track because the document is changing too much
    Joe Hildebrand (chair hat on): wants to nail the name nailed down before we go too far
    Francesca: let's discuss the name offline, let's take the discussion on the mailing list.
    Henk: I understand one of the preconditions for the standard track is the name. I see it obvious evolution rather than "innovation" in the document. Please raise in the list very soon.
    Matt: Accepting a doc as wg document doesn't mean it cannot be changed.
    Alexey: rate of change isn't that important until it is done.
        Stable means stable at the end of the discussion.
        Different discussion if it's changing or if it is standard track.
    Henk: OK, that clarifies.
    Alexey: As long as the core is stable, you can move the rest to another document.

Array tags: Carsten
    https://tools.ietf.org/html/draft-jroatch-cbor-tags-05

    * Which tag length? (sl. 26)
    Joe: way too many tags. one tag with an array [type, actual array] should work just fine.
        Carsten: Somewhat of a style question
    Sean: When I reviewed this when originally proposed last year, I was okay with the quantity of tags, but opposed to them being in the 2-byte space ( < 256). In the four-byte space, no big deal.
        Carsten: some arrays will be pretty short
        Joe: sets bad precedent
        Sean: my concern with Joe's proposal is that now we need another sub-registry for the type "tag" (not truly a tag, it's an enumeration). So I agree with Carsten
        Joe: let's discuss it offline

    How many people have read? ~7
    Call for action: reviews. Paul, Jim volunteered for review.
    Call for action: discussion on which tag length.

Time tags: Carsten
    https://tools.ietf.org/html/draft-bormann-cbor-time-tag-01

CBOR Tag for CBOR Templates: Carsten
    https://tools.ietf.org/html/draft-bormann-lpwan-cbor-template-00
    Joe: had a one-tag solution

Packed Tag: Carsten
    https://tools.ietf.org/html/draft-bormann-cbor-packed-00

Sean: reminds the WG that there is the OID document and other drafts that need more review